17 / 17 / 14
Регистрация: 06.08.2009
Сообщений: 500
1

Неверная функция AutoLisp

11.03.2016, 15:29. Показов 1356. Ответов 3
Метки нет (Все метки)

Добрый день. Подскажите пожалуйста, почему программа на AutoLisp ругается на строку (setq xxx 1) говорит "неверная функция":
Вот фрагмент программы где это происходит:
Lisp
1
2
3
4
5
6
7
8
        (if (and (< y1 0) (< x1 0))
          (
            (setq xxx 1)
                ;(setq x1 y1)
            ;(setq y1 tmp1)
          )
          ()
        )
Вот код всей программы:
Lisp
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
(DEFUN c:epicicloida() ; начало функции epicicloida
   ;(setq p1 (getpoint "\nУкажите базовую точку : ")); запрос координат базовой точки
 
  (setq a (/ 2.0 7.0))
  (setq b 1)
    
  
   (setq t1 0.0)
   (setq R 500)
   (setq step_t1 (/ Pi 20))
   (setq osm (getvar "osmode"))     ; запоминаем привязки пользователя
   (setvar "osmode" 0)          ; отключаем привязки
   (setvar 'PLINEWID 15)
 
   ;(setq x (* R (cos t1)))
   ;(setq y (* R (sin t1)))
 
   ;(setq l_part (* (+ 1 a) (cos (* a t1))))
   ;(setq l_right (* (* a b) (cos (* (+ 1 a) t1))))
   ;(setq l_right1 (cos (* (+ 1 a) t1)))
   
   (setq x1 (- (* (+ 1 a) (cos (* a t1))) (* (* a b) (cos (* (+ 1 a) t1)))))
   (setq y1 (- (* (+ 1 a) (sin (* a t1))) (* (* a b) (sin (* (+ 1 a) t1)))))
   (setq t1 (+ t1 step_t1))
   (setq p1 (list (* x1 R) (* y1 R)))
   (command "_color" 1)  
   (repeat 320
            (prompt (rtos t1))
            (prompt " Координаты: ")
        (prompt (rtos x1))
            (prompt ", ")
            (prompt (rtos y1))
            (prompt "; ")
        (setq x1 (- (* (+ 1 a) (cos (* a t1))) (* (* a b) (cos (* (+ 1 a) t1)))))
        (setq y1 (- (* (+ 1 a) (sin (* a t1))) (* (* a b) (sin (* (+ 1 a) t1)))))
 
            ;(setq x (* R (cos t1)))
        ;(setq y (* R (sin t1)))
     
        ;(setq x (- (* (+ 1 a) (cos (* a t1))) (* (a b) (cos (* (+1 a) t1)))))
        ;(setq y (- (* (+ 1 a) (sin (* a t1))) (* (a b) (sin (* (+1 a) t1)))))
        (setq p2 (list (* x1 R) (* y1 R)))      ; определение координат точки р2
     
      
        (command "_pline" p1 p2 "") 
      
      
        (setq t1 (+ t1 step_t1))
        (setq p1 p2)
   )
 
   (setvar 'PLINEWID 1)
   (command "_color" 2)
 
    ;Выполним преобразование
   (setq x1 (- (* (+ 1 a) (cos (* a t1))) (* (* a b) (cos (* (+ 1 a) t1)))))
   (setq y1 (- (* (+ 1 a) (sin (* a t1))) (* (* a b) (sin (* (+ 1 a) t1)))))
   (setq x1 (+ x1 (* 0.6 y1)))
   (setq t1 (+ t1 step_t1))
   (setq p1 (list (* x1 R) (* y1 R)))
  
   (repeat 320
            (prompt (rtos t1))
            (prompt " Координаты: ")
        (prompt (rtos x1))
            (prompt ", ")
            (prompt (rtos y1))
            (prompt "; ")
        (setq x1 (- (* (+ 1 a) (cos (* a t1))) (* (* a b) (cos (* (+ 1 a) t1)))))
        (setq y1 (- (* (+ 1 a) (sin (* a t1))) (* (* a b) (sin (* (+ 1 a) t1)))))
            (setq x1 (+ x1 (* 0.6 y1)))
 
            ;(if (and (< y1 0) (< x1 0)) (command "_color" 4) (command "_color" 2))
        (if (and (< y1 0) (< x1 0))
          (
            (setq xxx 1)
                ;(setq x1 y1)
            ;(setq y1 tmp1)
          )
          ()
        )
     
            ;(setq x (* R (cos t1)))
        ;(setq y (* R (sin t1)))
     
        ;(setq x (- (* (+ 1 a) (cos (* a t1))) (* (a b) (cos (* (+1 a) t1)))))
        ;(setq y (- (* (+ 1 a) (sin (* a t1))) (* (a b) (sin (* (+1 a) t1)))))
        (setq p2 (list (* x1 R) (* y1 R)))      ; определение координат точки р2
     
      
        (command "_pline" p1 p2 "") 
      
      
        (setq t1 (+ t1 step_t1))
        (setq p1 p2)
   )
 
  
   ;(command "_pline" (list 100 100) (list 600 600) "")
  
   (setvar "osmode" osm)            ; возвращаем привязки пользователя
  
)                   ; окончание функции
__________________
Помощь в написании контрольных, курсовых и дипломных работ, диссертаций здесь
0
Programming
Эксперт
94731 / 64177 / 26122
Регистрация: 12.04.2006
Сообщений: 116,782
11.03.2016, 15:29
Ответы с готовыми решениями:

Программист AutoLisp
Нужен программист AutoLisp для написания одного несложного приложения под AutoCad

Фрактал в Autolisp
Добрый день, уважаемые посетители форума! Подскажите пожалуйста, как можно построить фрактал из...

Autolisp Начертить полуокружность
Здравствуйте. Надо начертить полуокружность с центром в заданной точке. Длина и высота...

Нужен Программист autolisp
Задача следующая: Имеем файл в формате DWG, в файле нарисованы карты участков с помощью полилиний...

3
VH
424 / 253 / 22
Регистрация: 23.11.2010
Сообщений: 278
11.03.2016, 16:04 2
Lisp
1
2
3
4
(if (and (< y1 0) (< x1 0))
 ((setq xxx 1)) ; вычисляется в вызов функции (1), поэтому и ругается
 ()
)
1
598 / 830 / 141
Регистрация: 10.08.2015
Сообщений: 4,194
11.03.2016, 22:34 3
Lisp
1
2
3
4
5
6
7
8
(if (and (< y1 0) (< x1 0))
          (progn ;_ так должно быть
            (setq xxx 1)
                ;(setq x1 y1)
            ;(setq y1 tmp1)
          )
          ()
        )
1
17 / 17 / 14
Регистрация: 06.08.2009
Сообщений: 500
12.03.2016, 09:42  [ТС] 4
Спасибо
0
IT_Exp
Эксперт
87844 / 49110 / 22898
Регистрация: 17.06.2006
Сообщений: 92,604
12.03.2016, 09:42
Помогаю со студенческими работами здесь

AutoLisp: доработать меню
Дана задача выравнивание отрезков в автокаде, сам код я написал осталось дописать меню, чтобы можно...

Нанесение размеров AutoLisp
Как нанести такие размеры как на чертеже? Диаметры и линейные размеры я начертил, а вот как...

Штриховка фигуры AutoLisp
Здравствуйте! Подскажите как заштриховать круг? (defun main() (setq a (list 0 0)) (command...

Требуется вводный курс в AutoLISP
Здравствуйте, уважаемые знатоки! Есть ли среди вас умельцы популярно объяснять материал? Теория...


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
4
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin
Copyright ©2000 - 2022, CyberForum.ru